function State () {
  this.ended = this._ready = this._reading = this._destroyed = this._paused = false
}

State.prototype.end = function() {
  this.ended = true
  this._destroyed = false
}

State.prototype.ready = function() {
  this._ready = true
}

State.prototype.destroy = function() {
  this._destroyed = true
}

State.prototype.pause = function() {
  this._paused = true
}

State.prototype.resume = function() {
  this._paused = false
}

State.prototype.read = function() {
  this._reading = true
}

State.prototype.endRead = function() {
  this._reading = false
}

State.prototype.canPause = function() {
  return !this.ended && !this._paused
}

State.prototype.canResume = function() {
  return !this.ended && this._paused
}

State.prototype.canRead = function() {
  return !this.ended && !this._reading && !this._paused
}

State.prototype.canCleanup = function() {
  return !this.ended && !this._reading
}

State.prototype.canEmitData = function() {
  return !this.ended && !this._destroyed
}

State.prototype.canEnd = function() {
  return !this.ended
}

module.exports = function () { return new State() }